%define  oname uhashring
%def_without check

Name:    python3-module-%oname
Version: 2.1
Release: alt1.c10f1

Summary: Full featured consistent hashing python library compatible with ketama

License: BSD-3-Clause
Group:   Development/Python3
URL:     https://pypi.org/project/uhashring

# https://github.com/ultrabug/uhashring
Source:  %name-%version.tar

BuildRequires(pre): rpm-build-python3
BuildRequires: python3-module-setuptools
BuildRequires: python3-module-wheel

%if_with check
BuildRequires: python3-module-black >= 19.10b0
BuildRequires: python3-module-flake8 >= 3.7.9
BuildRequires: python3-module-isort >= 4.3.21
BuildRequires: python3-module-pytest-cov >= 2.8.1
BuildRequires: python3-module-pytest >= 5.4.1
BuildRequires: python3-module-memcached >= 1.59
BuildRequires: python3-module-tox >= 3.14.6
%endif

BuildArch: noarch

%description
uhashring implements consistent hashing in pure Python.

Consistent hashing is mostly used on distributed systems/caches/databases as this
avoid the total reshuffling of your key-node mappings when adding or removing a
node in your ring (called continuum on libketama). More information and details
about this can be found in the literature section.

This full featured implementation offers:
* a lot of convenient methods to use your consistent hash ring in real world
applications.
* simple integration with other libs such as memcache through monkey patching.
* a full ketama compatibility if you need to use it (see important mention below).
* all the missing functions in the libketama C python binding (which is not even
available on pypi) for ketama users.
* possibility to use your own weight and hash functions if you don't care about
the ketama compatibility.
* instance-oriented usage so you can use your consistent hash ring object
directly in your code (see advanced usage).
* native pypy support, since this is a pure python library.
* tests of implementation, key distribution and ketama compatibility.

Per node weight is also supported and will affect the nodes distribution on the
ring.

%prep
%setup

%build
%pyproject_build

%install
%pyproject_install

%check
%tox_create_default_config
%tox_check_pyproject

%files
%python3_sitelibdir/%oname
%python3_sitelibdir/%oname-%version.dist-info

%changelog
* Fri Apr 26 2024 Ilfat Aminov <aminov@altlinux.org> 2.1-alt1.c10f1
- Build 2.1 for ALT c10f1
